;;; DvorakJ
;;; 1.0.48 Script <http://www.autohotkey.com/>
;;; blechmusik (blechmusik@gmail.com) <http://blechmusik.xrea.jp/>

;;; ============================================================================
;;; ---------------- eݒ
;;; ============================================================================

SendMode Input
#NoEnv
#SingleInstance FORCE
#WinActivateForce
#UseHook
#persistent

;;; ============================================================================
;;; ---------------- IME.ahk.inc ̓ǂݍ
;;; ============================================================================

;;; IME.ahk  AutoHotokey𗬍s点Abv[_ <http://lukewarm.s101.xrea.com/up/>  089.zip [Shift&Space + IME.ahk] (2008/09/21 20:18) Ɋ܂܂Ă܂B
;;; IME.ahk  NYSL <http://www.kmonos.net/nysl/> ŌJĂ܂B

#Include ./inc/IME.ahk.inc
#Include ./inc/IME_GET.ahk.inc



;;; ============================================================================
;;; ---------------- ini t@CŊǗ鍀
;;; ============================================================================

#Include ./inc/ini.ahk.inc


;;; ============================================================================
;;; ---------------- h艺ʔz̐ݒ
;;; ============================================================================

#Include ./inc/layout/Lacquered_Getas.ahk.inc


;;; ============================================================================
;;; ---------------- QWERTY z񂩂 Dvorokzւ̕ϊ\
;;; ============================================================================

#Include ./inc/layout/QWERTY.ahk.inc

if Dvorak_Layout = 1
{
	#Include ./inc/layout/Dvorak_programmer.ahk.inc
}
else
{
	#Include ./inc/layout/Dvorak.ahk.inc


	if W_E_keys_assignment = 1
	{
		Dvorak_shift_sc00A := "<"
		Dvorak_shift_sc00B := ">"
		Dvorak_shift_sc011 := "("
		Dvorak_shift_sc012 := ")"
	}
	else
	if W_E_keys_assignment = 2
	{
		Dvorak_shift_sc00C := "<"
		Dvorak_shift_sc00D := ">"
		Dvorak_shift_sc011 := "{{}"
		Dvorak_shift_sc012 := "{}}"
	}


	if US_keyboard = 1
	{
		Dvorak_sc02B := "\"
		Dvorak_shift_sc02B := "|"
	}
}





;;; ============================================================================
;;; ---------------- Ǝ̓gݒ
;;; ============================================================================

#Include ./inc/special_extension.ahk.inc

;;; ============================================================================
;;; ---------------- EBhE̐ݒ
;;; ============================================================================


#Include ./inc/window.ahk.inc

;;; ============================================================================
;;; ---------------- Dvorak z QWERTY z̐؂ւ̐ݒ
;;; ============================================================================

#Include ./inc/toggle_layout.ahk.inc

;;; ============================================================================
;;; ---------------- IME ̗LƖ̐؂ւ̐ݒ
;;; ============================================================================

#Include ./inc/toggle_IME.ahk.inc

;;; ============================================================================
;;; ---------------- q̃`FbN𒆎~
;;; ============================================================================

ResetKeyChecking() {
	global Is_PriorHotkey_consonant := 0

	global Is_Youon_h =
	global Is_Youon_n =
	global Is_C =

	global Is_Priorkey_syouryaku =
	global Is_Priorkey_youon =
	global Is_Priorkey_sn =

	global special_extension_first = 
	return
}

;;; ============================================================================
;;; ---------------- Shift 
;;; ============================================================================

SendDvorak_ExtendedIMShift()
{
	ResetKeyChecking()

	global Extended_IM_On_Off
	global Extended_IM_Which
	global Dvorak_Layout
	global W_E_keys_assignment


	global IME_Mode
	global IME_ConvMode



	IfInString, A_ThisHotkey, +
		StringTrimLeft, this_key, A_ThisHotkey, 1
	IfInString, A_ThisHotkey, &
		StringTrimLeft, this_key, A_ThisHotkey, 8

	StringTrimRight, Dvorak_key, Dvorak_shift_%this_key%, 0



	if IME_Mode = 1
	{
		if IME_ConvMode < 16 ; ȓ͗p
			Send,+{%this_key%}
		else
		if Extended_IM_Which = 4
		{
			if A_PriorHotkey contains ~,*,^,#
				Prior_Dvorak_key = 
			else
			if A_PriorHotkey contains +,&
			{
				if A_PriorHotkey contains +
					StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 1
				else
				if A_PriorHotkey contains &
					StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 8

				StringTrimRight, Prior_Dvorak_key, Dvorak_shift_%Prior_Dvorak_key%, 0
			}
			else
				StringTrimRight, Prior_Dvorak_key, Dvorak_%A_PriorHotkey%, 0

			SendSouseiShift(Dvorak_key, Prior_Dvorak_key)
		}
		else
		{
			Send,%Dvorak_key%
		}
	}
	else
	{
		Send,%Dvorak_key%
	}

	return
}

;;; ============================================================================
;;; ---------------- Shift 
;;; ============================================================================

SendDvorak_ExtendedIM()
{
	global Extended_IM_Which
	global Extended_IM_On_Off
	global Special_extension

	global IME_Mode
	global IME_ConvMode

	if A_ThisHotkey not contains *
		StringTrimRight, Dvorak_key, Dvorak_%A_ThisHotkey%, 0
	else
		Dvorak_key = 

	if IME_Mode = 1
	{
		if IME_ConvMode < 16 ; ȓ͗p
		{
			Send,{%A_ThisHotkey%}
		}
		else
		{
			if A_PriorHotkey contains ~,*,^,#,!
				Prior_Dvorak_key =
			else
			if A_PriorHotkey contains +,&
			{
				if A_PriorHotkey contains +
					StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 1
				else
				if A_PriorHotkey contains &
					StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 8

				StringTrimRight, Prior_Dvorak_key, Dvorak_shift_%Prior_Dvorak_key%, 0
			}
			else
				StringTrimRight, Prior_Dvorak_key, Dvorak_%A_PriorHotkey%, 0


			If Special_extension = 1
			{
				SendSpecial_Key(Dvorak_key)
			}


			if Extended_IM_Which = 1
			{
				if Dvorak_key in a,o,e,u,i
				{
					SendDvorakJP_Vowel(Dvorak_key)
				}
				else ; diphthong and hatuon
				if Dvorak_key in ,,,`',.,`;,q,j,k,x
				{
					SendDvorakJP_Diphthong_and_Hatuon(Dvorak_key)
				}
				else
				if Dvorak_key in p,y,f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
				{
					SendDvorakJP_Consonant(Dvorak_key, Prior_Dvorak_key)
				}
				else
				{
					Send,{%Dvorak_key%}
					ResetKeyChecking()
				}
			}
			else
			if Extended_IM_Which = 2
			{
				SendDvorakY(Dvorak_key)
			}
			else
			if Extended_IM_Which = 3
			{
				if Dvorak_key in ,,,`',.,p,y,a,o,e,u,i,`;,q,j,k,x
				{
					SendACT_Vowel(Dvorak_key, Prior_Dvorak_key)
				}
				else
				if Dvorak_key in f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
				{
					SendACT_Consonant(Dvorak_key, Prior_Dvorak_key)
				}
				else
				{
					Send,{%Dvorak_key%}
					ResetKeyChecking()
				}
			}
			else
			if Extended_IM_Which = 4
			{
				SendSousei_Normal(Dvorak_key, Prior_Dvorak_key)
			}
			else
			if Extended_IM_Which = 5
			{
				if Dvorak_key in ,,,`',.,p,y,a,o,e,u,i,`;,q,j,k,x
				{
					SendJLOD_Vowel(Dvorak_key, Prior_Dvorak_key)
				}
				else
				if Dvorak_key in f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
				{
					SendJLOD_Consonant(Dvorak_key, Prior_Dvorak_key)
				}
				else
				{
					Send,{%Dvorak_key%}
					ResetKeyChecking()
				}
			}
			else
			if Extended_IM_Which = 6 ; ʔz
			{
				if Dvorak_key in -
					Send,{BackSpace}
				else
				if Dvorak_key in /
					onKeyDown("_AT")
				else
				if Dvorak_key in s
					onKeyDown("_SColon")
				else
				if Dvorak_key in w
					onKeyDown("_Comma")
				else
				if Dvorak_key in v
					onKeyDown("_Dot")
				else
				if Dvorak_key in =
					Send,^c
				else
				if Dvorak_key in ,,,`',.,`;,/,q,j,k,x,p,y,f,g,c,r,l,a,o,e,u,i,d,h,t,n,b,m
				{
					StringTrimRight, QWERTY_key, QWERTY_%A_ThisHotkey%, 0
					StringUpper, QWERTY_key, QWERTY_key
					QWERTY_key = _%QWERTY_key%
					onKeyDown(QWERTY_key)
				}
				else
					Send,%Dvorak_key%
			}
			else
			if Extended_IM_Which = 7 ; h艺ʔz
			{
				if Dvorak_key in -
					Send,{Enter}
				else
				if Dvorak_key in /
					onKeyDown("_AT")
				else
				if Dvorak_key in s
					onKeyDown("_SColon")
				else
				if Dvorak_key in w
					onKeyDown("_Comma")
				else
				if Dvorak_key in v
					onKeyDown("_Dot")
				else
				if Dvorak_key in z
					onKeyDown("_Slash")
				else
				if Dvorak_key in \
					onKeyDown("_BackSlash")
				else
				if Dvorak_key in =
					Send,^c
				else
				if Dvorak_key in ``
					Send,^x
				else
				if Dvorak_key in [
					Send,^v
				else
				if Dvorak_key in ]
					Send,{ESC}
				else
				if Dvorak_key in ,,,`',.,`;,/,q,j,k,x,p,y,f,g,c,r,l,a,o,e,u,i,d,h,t,n,b,m
				{
					StringTrimRight, QWERTY_key, QWERTY_%A_ThisHotkey%, 0
					StringUpper, QWERTY_key, QWERTY_key
					QWERTY_key = _%QWERTY_key%
					onKeyDown(QWERTY_key)
				}
				else
					Send,%Dvorak_key%
			}
			else
			{
				Send,%Dvorak_key%
			}
		}
	}
	else
	{
		Send,%Dvorak_key%
	}

	return
}

;;; ============================================================================
;;; ---------------- {͂̐ݒ
;;; ============================================================================

#Include ./inc/layout/DvorakJP.ahk.inc
#Include ./inc/layout/DvorakY.ahk.inc
#Include ./inc/layout/ACT.ahk.inc
#Include ./inc/layout/Sousei.ahk.inc
#Include ./inc/layout/JLOD.ahk.inc

;;; ============================================================================
;;; ---------------- h j k l ̃L[ŃJ[\ړ
;;; ============================================================================

#Include ./inc/hjkl.ahk.inc

;;; ============================================================================
;;; ---------------- ESC ̃L[̊g
;;; ============================================================================

#Include ./inc/ESC.ahk.inc

;;; ============================================================================
;;; ---------------- CapsLock PƂœ͂Ƃɂ BackSpace Ƃ
;;; ============================================================================

#Include ./inc/CapsLock_to_BackSpace.ahk.inc

;;; ============================================================================
;;; ---------------- Xy[XEL[VtgL[̂ƂĎgp邽߂̏
;;; ============================================================================

+space::
	ResetKeyChecking()
	Send,+{space}
	return

space::
	ResetKeyChecking()
	Send,{space}
	return

;;; ============================================================================
;;; ---------------- REMAP TO DVORAK
;;; ============================================================================

;;; ============================================================================
;;; ---------------- łɃVtgEL[Ƃ̑gݍ킹`̂QƂ
;;; ============================================================================

Space & sc002::
Space & sc003::
Space & sc004::
Space & sc005::
Space & sc006::
Space & sc007::
Space & sc008::
Space & sc009::
Space & sc00A::
Space & sc00B::
Space & sc00C::
Space & sc00D::
Space & sc07D::
Space & sc010::
Space & sc011::
Space & sc012::
Space & sc013::
Space & sc014::
Space & sc015::
Space & sc016::
Space & sc017::
Space & sc018::
Space & sc019::
Space & sc01A::
Space & sc01B::
Space & sc01E::
Space & sc01F::
Space & sc020::
Space & sc021::
Space & sc022::
Space & sc023::
Space & sc024::
Space & sc025::
Space & sc026::
Space & sc027::
Space & sc028::
Space & sc02B::
Space & sc02C::
Space & sc02D::
Space & sc02E::
Space & sc02F::
Space & sc030::
Space & sc031::
Space & sc032::
Space & sc033::
Space & sc034::
Space & sc035::
Space & sc073::
	if SandS = 1
	{
		SendDvorak_ExtendedIMShift()
	}
	else
	{
		Send,{%A_ThisHotkey%}
	}

	return


;;; ============================================================================
;;; ---------------- VtgL[ĂƂ̐ݒ
;;; ============================================================================
;;; ============================================================================
;;; ---------------- łɃVtgEL[Ƃ̑gݍ킹`̂QƂ
;;; ============================================================================

+sc002::
+sc003::
+sc004::
+sc005::
+sc006::
+sc007::
+sc008::
+sc009::
+sc00A::
+sc00B::
+sc00C::
+sc00D::
+sc07D::
+sc010::
+sc011::
+sc012::
+sc013::
+sc014::
+sc015::
+sc016::
+sc017::
+sc018::
+sc019::
+sc01A::
+sc01B::
+sc01E::
+sc01F::
+sc020::
+sc021::
+sc022::
+sc023::
+sc024::
+sc025::
+sc026::
+sc027::
+sc028::
+sc02B::
+sc02C::
+sc02D::
+sc02E::
+sc02F::
+sc030::
+sc031::
+sc032::
+sc033::
+sc034::
+sc035::
+sc073::
	SendDvorak_ExtendedIMShift()
	return


;;; ============================================================================
;;; ---------------- L[PƂœ͂Ƃ
;;; ============================================================================



sc002::
sc003::
sc004::
sc005::
sc006::
sc007::
sc008::
sc009::
sc00A::
sc00B::
sc00C::
sc00D::
sc07D::
sc010::
sc011::
sc012::
sc013::
sc014::
sc015::
sc016::
sc017::
sc018::
sc019::
sc01A::
sc01B::
sc01E::
sc01F::
sc020::
sc021::
sc022::
sc023::
sc024::
sc025::
sc026::
sc027::
sc028::
sc02B::
sc02C::
sc02D::
sc02E::
sc02F::
sc030::
sc031::
sc032::
sc033::
sc034::
sc035::
sc073::
	SendDvorak_ExtendedIM()
	return


;;; ============================================================================
;;; ---------------- Ԃ̕ێ𒆎~
;;; ============================================================================




~*Up::
~*Down::
~*Left::
~*Right::
~*Ins::
~*Home::
~*End::
~*PgUp::
~*PgDn::
~*BS::
~*Delete::
~*Esc::
~*Tab::
~*Enter::
~*NumpadDiv::
~*NumpadMult::
~*NumpadAdd::
~*NumpadSub::
~*NumpadEnter::
~*NumpadDel::
~*NumpadIns::
~*NumpadClear::
~*NumpadUp::
~*NumpadDown::
~*NumpadLeft::
~*NumpadRight::
~*NumpadHome::
~*NumpadEnd::
~*NumpadPgUp::
~*NumpadPgDn::
~*Numpad0::
~*Numpad1::
~*Numpad2::
~*Numpad3::
~*Numpad4::
~*Numpad5::
~*Numpad6::
~*Numpad7::
~*Numpad8::
~*Numpad9::
~*NumpadDot::
~*F1::
~*F2::
~*F3::
~*F4::
~*F5::
~*F6::
~*F7::
~*F8::
~*F9::
~*F10::
~*F11::
~*F12::
	ResetKeyChecking()
	Return


;;; ============================================================================
;;; ---------------- L̐ݒȊO
;;; ============================================================================


*sc002::
*sc003::
*sc004::
*sc005::
*sc006::
*sc007::
*sc008::
*sc009::
*sc00A::
*sc00B::
*sc00C::
*sc00D::
*sc07D::
*sc010::
*sc011::
*sc012::
*sc013::
*sc014::
*sc015::
*sc016::
*sc017::
*sc018::
*sc019::
*sc01A::
*sc01B::
*sc01E::
*sc01F::
*sc020::
*sc021::
*sc022::
*sc023::
*sc024::
*sc025::
*sc026::
*sc027::
*sc028::
*sc02B::
*sc02C::
*sc02D::
*sc02E::
*sc02F::
*sc030::
*sc031::
*sc032::
*sc033::
*sc034::
*sc035::
*sc073::
	ResetKeyChecking()

	StringTrimLeft, sc_key, A_ThisHotkey, 1

	StringTrimRight, QWERTY_key, QWERTY_%sc_key%, 0
	StringTrimRight, QWERTY_shift_key, QWERTY_shift_%sc_key%, 0
	StringTrimRight, Dvorak_key, Dvorak_%sc_key%, 0
	StringTrimRight, Dvorak_shift_key, Dvorak_shift_%sc_key%, 0

	Modifiers =
	GetKeyState, state1, LWin
	GetKeyState, state2, RWin
	state = %state1%%state2%


	if state <> UU  ; At least one Windows key is down.
		Modifiers = #


	GetKeyState, state, Alt
	if state = D
		Modifiers = %Modifiers%!


	GetKeyState, state1, Control
	GetKeyState, state2, Shift


	;; QWERTY zɐ؂ւƂŁA Ctrl ĂƂ
	if InStr(Ctrl_Dvorak, 0) && InStr(state1, "D")
	{
		Modifiers = %Modifiers%^


		if state2 = D
			this_key = %QWERTY_shift_key%
		else
			this_key = %QWERTY_key%
	}
	else
	{
		;; Ctrl ĂƂ
		if state1 = D 
			Modifiers = %Modifiers%^


		if state2 = D
			this_key = %Dvorak_shift_key%
		else
			this_key = %Dvorak_key%
	}


	if QWERTY_key in h,j,k,l
	{
		if InStr(Win_hjkl, 1) && InStr(Modifiers, "#") && InStr(state2, "U")
			Send_hjkl(QWERTY_key)
		else
		if InStr(Shift_Ctrl_hjkl, 1) && InStr(Modifiers, "^") && InStr(state2, "D")
			Send_hjkl(QWERTY_key)
		else
			Send,%Modifiers%%this_key%
	}
	else
	if InStr(Ctrl_M_to_Enter, 1) && InStr(Modifiers, "^") && InStr(this_key, "m")
		Send,{Enter}
	else
		Send,%Modifiers%%this_key%

	return



#UseHook off




;;; ============================================================================
;;; ---------------- Tu[`̐ݒ
;;; ============================================================================

#Include ./inc/subroutine.ahk.inc
